/*
 *
*/
#include "gazebo/gazebo.hh"
#include "gazebo/plugins/CameraPlugin.hh"
#include "robot.h"

namespace gazebo
{
  class CameraDump : public CameraPlugin
  {

		int frame_count = 0; 
    public: CameraDump() : CameraPlugin(), saveCount(0) {}

    public: void Load(sensors::SensorPtr _parent, sdf::ElementPtr _sdf)
    {
      // Don't forget to load the camera plugin
      CameraPlugin::Load(_parent, _sdf);
    }

    // Update the controller
    public: void OnNewFrame(const unsigned char *_image,
        unsigned int _width, unsigned int _height, unsigned int _depth,
        const std::string &_format)
    {
      char tmp[1024];
      snprintf(tmp, sizeof(tmp), 
//					"/tmp/%s-%04d.jpg",
					"%s-%04d.jpg",
          this->parentSensor->Camera()->Name().c_str(), this->saveCount);

      if (this->saveCount < 1000 && frame_count % 1000 == 0)
      {
        this->parentSensor->Camera()->SaveFrame(
            _image, _width, _height, _depth, _format, tmp);
        gzmsg << "Saving frame [" << this->saveCount
              << "] as [" << tmp << "]\n";
			// Save image data to tmp file
			std::ifstream img_file(std::string(IMAGE_FILE)+std::string(".bin"));
    if(img_file.fail()){
        //File does not exist: dump one
			std::cout << "Saving "<<frame_count<<" to '" << IMAGE_FILE << "' width="<<_width<<", height="<<_height<<", depth="<<_depth<<", format="<<_format<<std::endl;
    }
        this->saveCount++;
      }
			frame_count++;
    }

    private: int saveCount;
  };

  // Register this plugin with the simulator
  GZ_REGISTER_SENSOR_PLUGIN(CameraDump)
}
